import java.awt.EventQueue;

import jomp.compiler.Jomp;

/**
 * Dies ist der Output von JOMP aus OmpDemo.jomp. JOMP konvertiert sogar die
 * Sonderzeichen in Kommentaren, wie man im unteren Kommentar sehen kann.
 * Was ist das fr eine Klasse in Zeile 51?
 * Was wird wohl in den Zeilen 76-78 gemacht?
 */

/** 
 * Diese Klasse wendet OMP an um die Performance der for-Schleife zu verbessern.
 * Um JOMP zu sagen, sie solle tats\u00e4chlich mehrere Threads zur
 * Ausf\u00fchrung verwenden, solltest du der JVM das Argument -Djomp.threads=4
 * mitgeben. Dies kannst du in Eclipse unter Run -> Run Configuration -> links
 * OmpDemo.java ausw\u00e4hlen -> Ins Textfeld VM Arguments -Djomp.threads=4
 * reinschreiben.
 */
public class OmpDemo {

	public static void main(String[] args) {

		try {

			// OMP PARALLEL BLOCK BEGINS
			{
				__omp_Class0 __omp_Object0 = new __omp_Class0();
				// shared variables
				__omp_Object0.args = args;
				// firstprivate variables
				try {
					jomp.runtime.OMP.doParallel(__omp_Object0);
				} catch (Throwable __omp_exception) {
					System.err
							.println("OMP Warning: Illegal thread exception ignored!");
					System.err.println(__omp_exception);
				}
				// reduction variables
				// shared variables
				args = __omp_Object0.args;
			}
			// OMP PARALLEL BLOCK ENDS

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	// OMP PARALLEL REGION INNER CLASS DEFINITION BEGINS
	private static class __omp_Class0 extends jomp.runtime.BusyTask {
		// shared variables
		String[] args;

		// firstprivate variables
		// variables to hold results of reduction

		public void go(int __omp_me) throws Throwable {
			// firstprivate variables + init
			// private variables
			// reduction variables, init to default
			// OMP USER CODE BEGINS

			{ // OMP FOR BLOCK BEGINS
				// copy of firstprivate variables, initialized
				// copy of lastprivate variables
				// variables to hold result of reduction
				boolean amLast = false;
				{
					// firstprivate variables + init
					// [last]private variables
					// reduction variables + init to default
					// -------------------------------------
					jomp.runtime.LoopData __omp_WholeData2 = new jomp.runtime.LoopData();
					jomp.runtime.LoopData __omp_ChunkData1 = new jomp.runtime.LoopData();
					__omp_WholeData2.start = (long) (0);
					__omp_WholeData2.stop = (long) (10);
					__omp_WholeData2.step = (long) (1);
					jomp.runtime.OMP.setChunkStatic(__omp_WholeData2);
					while (!__omp_ChunkData1.isLast
							&& jomp.runtime.OMP.getLoopStatic(__omp_me,
									__omp_WholeData2, __omp_ChunkData1)) {
						for (;;) {
							if (__omp_WholeData2.step > 0) {
								if (__omp_ChunkData1.stop > __omp_WholeData2.stop)
									__omp_ChunkData1.stop = __omp_WholeData2.stop;
								if (__omp_ChunkData1.start >= __omp_WholeData2.stop)
									break;
							} else {
								if (__omp_ChunkData1.stop < __omp_WholeData2.stop)
									__omp_ChunkData1.stop = __omp_WholeData2.stop;
								if (__omp_ChunkData1.start > __omp_WholeData2.stop)
									break;
							}
							for (int i = (int) __omp_ChunkData1.start; i < __omp_ChunkData1.stop; i += __omp_ChunkData1.step) {
								// OMP USER CODE BEGINS
								{
									System.out.println("Thread "
											+ Thread.currentThread().getName()
											+ ", id="
											+ Thread.currentThread().getId());
									// OMP CRITICAL BLOCK BEGINS
									synchronized (jomp.runtime.OMP
											.getLockByName("")) {
										// OMP USER CODE BEGINS

										{
											Thread.sleep(100);
										}
										// OMP USER CODE ENDS
									}
									// OMP CRITICAL BLOCK ENDS

									// System.out.println("fertig");
								}
								// OMP USER CODE ENDS
								if (i == (__omp_WholeData2.stop - 1))
									amLast = true;
							} // of for
							if (__omp_ChunkData1.startStep == 0)
								break;
							__omp_ChunkData1.start += __omp_ChunkData1.startStep;
							__omp_ChunkData1.stop += __omp_ChunkData1.startStep;
						} // of for(;;)
					} // of while
					// call reducer
					jomp.runtime.OMP.doBarrier(__omp_me);
					// copy lastprivate variables out
					if (amLast) {
					}
				}
				// set global from lastprivate variables
				if (amLast) {
				}
				// set global from reduction variables
				if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
				}
			} // OMP FOR BLOCK ENDS

			// OMP USER CODE ENDS
			// call reducer
			// output to _rd_ copy
			if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
			}
		}
	}
	// OMP PARALLEL REGION INNER CLASS DEFINITION ENDS

}
